diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 9ff87705c..2a9e7d557 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -5,7 +5,6 @@ import static net.minecraft.core.Global.*;
 import java.util.ArrayList;
 import java.util.Collection;
 import java.util.HashSet;
-import java.util.Iterator;
 import java.util.LinkedList;
 import java.util.List;
 import java.util.Random;
@@ -58,6 +57,7 @@ import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.LightUpdate;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
 import net.minecraft.core.world.save.DimensionData;
@@ -82,6 +82,15 @@ public class World implements WorldSource {
 
     public static final int HEIGHT_BLOCKS = 256;
     public static final int MAX_BRIGHTNESS = 15;
+
+    public static final int MAX_BLOCK_X = 32000000;
+    public static final int MAX_BLOCK_Z = 32000000;
+    public static final int MIN_BLOCK_X = -32000000;
+    public static final int MIN_BLOCK_Z = -32000000;
+
+    public static final int MAX_SCHEDULED_TICKS_IN_TICK = 1000;
+    public static final int ANIMATION_TICKS_PER_TICK = 1000;
+
     private final List<LightUpdate> lightingToUpdate = new LinkedList<>();
     public List<Entity> loadedEntityList = new ArrayList<>();
     private final List<Entity> unloadedEntityList = new ArrayList<>();
@@ -120,7 +129,6 @@ public class World implements WorldSource {
     public SavedDataStorage savedDataStorage;
     private boolean updatingBlockEntities;
     private int lightingUpdatesCounter = 0;
-    public final SpawnerMobs.SpawnerConfig spawningConfig;
     static int lightingUpdatesScheduled = 0;
     private int caveSoundCounter = rand.nextInt(12000);
     public boolean isClientSide = false;
@@ -139,12 +147,12 @@ public class World implements WorldSource {
     private CommandManager commandManager;
 
     //Usually called when a world is loaded or generated (Singleplayer & Server)
-    public World(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType, SpawnerMobs.SpawnerConfig spawningConfig)
+    public World(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType)
     {
         this.saveHandler = saveHandler;
         this.savedDataStorage = new SavedDataStorage(saveHandler);
         this.levelData = saveHandler.getLevelData();
-        this.spawningConfig = spawningConfig;
+
         this.isNewWorld = levelData == null;
 
         // Attempt to determine the correct dimension for this world
@@ -236,7 +244,6 @@ public class World implements WorldSource {
         saveHandler = world.saveHandler;
 
         levelData = new LevelData(world.levelData);
-        this.spawningConfig = world.spawningConfig;
 
         dimensionData = world.saveHandler.getDimensionData(dimension.id);
         if (dimensionData == null)
@@ -292,8 +299,6 @@ public class World implements WorldSource {
 
         biomeProvider = this.worldType.createBiomeProvider(this);
 
-        spawningConfig = new SpawnerMobs.SpawnerConfig();
-
         this.commandManager = new CommandManager(isServer);
         this.commandManager.init();
     }
@@ -313,8 +318,6 @@ public class World implements WorldSource {
         auroraProvider = new AuroraProvider(this, 0);
 
         biomeProvider = this.worldType.createBiomeProvider(this);
-
-        spawningConfig = new SpawnerMobs.SpawnerConfig();
     }
 
     public <T> T getGameRuleValue(GameRule<T> gameRule)
@@ -322,6 +325,10 @@ public class World implements WorldSource {
         return levelData.getGameRules().getValue(gameRule);
     }
 
+    public SpawnerConfig getSpawnerConfig() {
+        return levelData.getSpawnerConfig();
+    }
+
     public int getHeightBlocks()
     {
         return Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
@@ -442,7 +449,7 @@ public class World implements WorldSource {
     @Override
     public int getBlockId(int x, int y, int z)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return 0;
         }
@@ -467,7 +474,7 @@ public class World implements WorldSource {
     @Override
     public double getBlockTemperature(int x, int z)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return 0;
         }
@@ -499,7 +506,7 @@ public class World implements WorldSource {
     @Override
     public double getBlockHumidity(int x, int z)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return 0;
         }
@@ -536,7 +543,7 @@ public class World implements WorldSource {
 
     public double getBlockVariety(int x, int z)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return 0;
         }
@@ -569,7 +576,7 @@ public class World implements WorldSource {
     @Override
     public @NotNull Biome getBlockBiome(int x, int y, int z)
     {
-        if(x < -32000000 || z < -32000000 || x >= 32000000 || z > 32000000)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return Biomes.OVERWORLD_PLAINS;
         }
@@ -603,7 +610,7 @@ public class World implements WorldSource {
 
     public boolean getBlockLitInteriorSurface(int x, int y, int z)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return true;
         }
@@ -683,7 +690,7 @@ public class World implements WorldSource {
 
     public boolean setBlockAndMetadata(int x, int y, int z, int id, int meta)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return false;
         }
@@ -701,9 +708,12 @@ public class World implements WorldSource {
         }
     }
 
-    public boolean setBlockRaw(int x, int y, int z, int id)
+    public boolean setBlockRaw(int x, int y, int z, int id) {
+        return setBlockAndMetadataRaw(x, y, z, id, getBlockMetadata(x, y, z));
+    }
+    public boolean setBlockAndMetadataRaw(int x, int y, int z, int id, int meta)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return false;
         }
@@ -717,13 +727,13 @@ public class World implements WorldSource {
         } else
         {
             Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            return chunk.setBlockIDRaw(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), id);
+            return chunk.setBlockIDWithMetadataRaw(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), id, meta);
         }
     }
 
     public boolean setBlock(int x, int y, int z, int id)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return false;
         }
@@ -757,7 +767,7 @@ public class World implements WorldSource {
     @Override
     public int getBlockMetadata(int x, int y, int z)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return 0;
         }
@@ -783,8 +793,7 @@ public class World implements WorldSource {
         {
             markBlockNeedsUpdate(x, y, z);
             int id = getBlockId(x, y, z);
-            // TODO
-            // The name neighborNotifyOnMetadataChangeDisabled suggests that this should be inverted, but doing that breaks redstone
+            // TODO The name neighborNotifyOnMetadataChangeDisabled suggests that this should be inverted, but doing that breaks redstone
             if(Block.neighborNotifyOnMetadataChangeDisabled[id & 0x3fff])
             {
                 notifyBlocksOfNeighborChange(x, y, z, id);
@@ -794,7 +803,7 @@ public class World implements WorldSource {
 
     public boolean setBlockMetadata(int x, int y, int z, int meta)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return false;
         }
@@ -815,18 +824,6 @@ public class World implements WorldSource {
         }
     }
 
-    public boolean setBlockRawWithNotify(int x, int y, int z, int id)
-    {
-        if(setBlockRaw(x, y, z, id))
-        {
-            notifyBlockChange(x, y, z, id);
-            return true;
-        } else
-        {
-            return false;
-        }
-    }
-
     public boolean setBlockWithNotify(int x, int y, int z, int id)
     {
         if(setBlock(x, y, z, id))
@@ -933,26 +930,26 @@ public class World implements WorldSource {
         return getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)).getRawBrightness(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), 0);
     }
 
-    public int getBlockLightValue(int i, int j, int k)
+    public int getBlockLightValue(int x, int y, int z)
     {
-        return getBlockLightValue_do(i, j, k, true);
+        return getBlockLightValue_do(x, y, z, true);
     }
 
-    public int getBlockLightValue_do(int i, int j, int k, boolean flag)
+    public int getBlockLightValue_do(int x, int y, int z, boolean first)
     {
-        if(i < 0xfe17b800 || k < 0xfe17b800 || i >= 0x1e84800 || k > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return MAX_BRIGHTNESS;
         }
-        if(flag)
+        if(first)
         {
-            if(getBlockLitInteriorSurface(i, j, k))
+            if(getBlockLitInteriorSurface(x, y, z))
             {
-                int i1 = getBlockLightValue_do(i, j + 1, k, false);
-                int j1 = getBlockLightValue_do(i + 1, j, k, false);
-                int k1 = getBlockLightValue_do(i - 1, j, k, false);
-                int l1 = getBlockLightValue_do(i, j, k + 1, false);
-                int i2 = getBlockLightValue_do(i, j, k - 1, false);
+                int i1 = getBlockLightValue_do(x, y + 1, z, false);
+                int j1 = getBlockLightValue_do(x + 1, y, z, false);
+                int k1 = getBlockLightValue_do(x - 1, y, z, false);
+                int l1 = getBlockLightValue_do(x, y, z + 1, false);
+                int i2 = getBlockLightValue_do(x, y, z - 1, false);
                 if(j1 > i1)
                 {
                     i1 = j1;
@@ -972,60 +969,60 @@ public class World implements WorldSource {
                 return i1;
             }
         }
-        if(j < 0)
+        if(y < 0)
         {
             return 0;
         }
-        if(j >= getHeightBlocks())
+        if(y >= getHeightBlocks())
         {
-            j = getHeightBlocks() - 1;
+            y = getHeightBlocks() - 1;
         }
-        Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(k, Chunk.CHUNK_SIZE_Z));
-        i &= (Chunk.CHUNK_SIZE_X - 1);
-        k &= (Chunk.CHUNK_SIZE_Z - 1);
-        return chunk.getRawBrightness(i, j, k, skyDarken);
+        Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
+        x &= (Chunk.CHUNK_SIZE_X - 1);
+        z &= (Chunk.CHUNK_SIZE_Z - 1);
+        return chunk.getRawBrightness(x, y, z, skyDarken);
     }
 
-    public boolean canExistingBlockSeeTheSky(int i, int j, int k)
+    public boolean canExistingBlockSeeTheSky(int x, int y, int z)
     {
-        if(i < 0xfe17b800 || k < 0xfe17b800 || i >= 0x1e84800 || k > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return false;
         }
-        if(j < 0)
+        if(y < 0)
         {
             return false;
         }
-        if(j >= getHeightBlocks())
+        if(y >= getHeightBlocks())
         {
             return true;
         }
-        if(!isChunkLoaded(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(k, Chunk.CHUNK_SIZE_Z)))
+        if(!isChunkLoaded(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)))
         {
             return false;
         } else
         {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(k, Chunk.CHUNK_SIZE_Z));
-            i &= (Chunk.CHUNK_SIZE_X - 1);
-            k &= (Chunk.CHUNK_SIZE_Z - 1);
-            return chunk.canBlockSeeTheSky(i, j, k);
+            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
+            x &= (Chunk.CHUNK_SIZE_X - 1);
+            z &= (Chunk.CHUNK_SIZE_Z - 1);
+            return chunk.canBlockSeeTheSky(x, y, z);
         }
     }
 
-    public int getHeightValue(int i, int j)
+    public int getHeightValue(int x, int z)
     {
-        if(i < 0xfe17b800 || j < 0xfe17b800 || i >= 0x1e84800 || j > 0x1e84800)
+        if(x < World.MIN_BLOCK_X || z < World.MIN_BLOCK_Z || x >= World.MAX_BLOCK_X || z > World.MAX_BLOCK_Z)
         {
             return 0;
         }
-        if(!isChunkLoaded(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(j, Chunk.CHUNK_SIZE_Z)))
+        if(!isChunkLoaded(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)))
         {
             return 0;
         }
         else
         {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(j, Chunk.CHUNK_SIZE_Z));
-            return chunk.getHeightValue(i & (Chunk.CHUNK_SIZE_X - 1), j & (Chunk.CHUNK_SIZE_Z - 1));
+            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
+            return chunk.getHeightValue(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1));
         }
     }
 
@@ -1071,7 +1068,7 @@ public class World implements WorldSource {
         {
             y = getHeightBlocks() - 1;
         }
-        if(y < 0 || y >= getHeightBlocks() || x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(y < 0 || y >= getHeightBlocks() || x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return layer.defaultLightLevel;
         }
@@ -1090,7 +1087,7 @@ public class World implements WorldSource {
 
     public void setLightValue(LightLayer layer, int x, int y, int z, int value)
     {
-        if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
+        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
         {
             return;
         }
@@ -1192,10 +1189,10 @@ public class World implements WorldSource {
         Block block = Block.blocksList[id];
         if((!ignoreNonColliderBlocks || block == null || block.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && id > 0 && (block.canCollideCheck(meta, shouldCollideWithFluids)))
         {
-            HitResult movingobjectposition = block.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end);
-            if(movingobjectposition != null)
+            HitResult hitResult = block.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end);
+            if(hitResult != null)
             {
-                return movingobjectposition;
+                return hitResult;
             }
         }
         for(int l1 = 200; l1-- >= 0;)
@@ -1323,15 +1320,14 @@ public class World implements WorldSource {
                 blockStartZ--;
                 vec32.z++;
             }
-            int j2 = getBlockId(blockStartX, blockStartY, blockStartZ);
-            int k2 = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
-            Block block1 = Block.blocksList[j2];
-            if((!ignoreNonColliderBlocks || block1 == null || block1.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && j2 > 0 && block1.canCollideCheck(k2, shouldCollideWithFluids))
+            Block block1 = getBlock(blockStartX, blockStartY, blockStartZ);
+            int metadata1 = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
+            if((!ignoreNonColliderBlocks || block1 == null || block1.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && block1 != null && block1.canCollideCheck(metadata1, shouldCollideWithFluids))
             {
-                HitResult movingobjectposition1 = block1.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end);
-                if(movingobjectposition1 != null)
+                HitResult hitResult = block1.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end);
+                if(hitResult != null)
                 {
-                    return movingobjectposition1;
+                    return hitResult;
                 }
             }
         }
@@ -1339,7 +1335,7 @@ public class World implements WorldSource {
         return null;
     }
     
-    public void playSoundAtEntity(@Nullable Entity player, Entity entity, String soundPath, float volume, float pitch)
+    public void playSoundAtEntity(@Nullable Entity player, @NotNull Entity entity, String soundPath, float volume, float pitch)
     {
         for (LevelListener listener : listeners)
         {
@@ -1584,13 +1580,13 @@ public class World implements WorldSource {
         }
 
         double d = 0.25D;
-        List list = getEntitiesWithinAABBExcludingEntity(entity, axisalignedbb.grow(d, d, d));
+        List<Entity> list = getEntitiesWithinAABBExcludingEntity(entity, axisalignedbb.grow(d, d, d));
         for(int j2 = 0; j2 < list.size(); j2++)
         {
-            AABB axisalignedbb1 = ((Entity)list.get(j2)).getBb();
-            if(axisalignedbb1 != null && axisalignedbb1.intersects(axisalignedbb))
+            AABB aabb = ((Entity)list.get(j2)).getBb();
+            if(aabb != null && aabb.intersects(axisalignedbb))
             {
-                collidingBoundingBoxes.add(axisalignedbb1);
+                collidingBoundingBoxes.add(aabb);
             }
         }
 
@@ -1746,22 +1742,22 @@ public class World implements WorldSource {
         return -1;
     }
     
-    public int findTopSolidNonLiquidBlock(int i, int j)
+    public int findTopSolidNonLiquidBlock(int x, int z)
     {
-        Chunk chunk = getChunkFromBlockCoords(i, j);
-        int k = getHeightBlocks() - 1;
-        i &= (Chunk.CHUNK_SIZE_X - 1);
-        j &= (Chunk.CHUNK_SIZE_Z - 1);
-        while(k > 0) 
+        Chunk chunk = getChunkFromBlockCoords(x, z);
+        int y = getHeightBlocks() - 1;
+        x &= (Chunk.CHUNK_SIZE_X - 1);
+        z &= (Chunk.CHUNK_SIZE_Z - 1);
+        while(y > 0)
         {
-            int l = chunk.getBlockID(i, k, j);
-            Material material = l != 0 ? Block.blocksList[l].blockMaterial : Material.air;
+            Block block = Block.getBlock(chunk.getBlockID(x, y, z));
+            Material material = block != null ? block.blockMaterial : Material.air;
             if(!material.blocksMotion())
             {
-                k--;
+                y--;
             } else
             {
-                return k + 1;
+                return y + 1;
             }
         }
         return -1;
@@ -1975,10 +1971,10 @@ public class World implements WorldSource {
     public boolean checkIfAABBIsClear(AABB axisalignedbb)
     {
         if (axisalignedbb == null) return true;
-        List list = getEntitiesWithinAABBExcludingEntity(null, axisalignedbb);
+        List<Entity> list = getEntitiesWithinAABBExcludingEntity(null, axisalignedbb);
         for(int i = 0; i < list.size(); i++)
         {
-            Entity entity = (Entity)list.get(i);
+            Entity entity = list.get(i);
             if (entity instanceof FireflyClusterMob) continue;
             if(!entity.removed && entity.blocksBuilding)
             {
@@ -2011,9 +2007,9 @@ public class World implements WorldSource {
 		List<Entity> entities = getEntitiesWithinAABBExcludingEntity(null, boundingBox);
 
         for (Entity entity : entities) {
-            AABB axisalignedbb1 = entity.getBb();
-            if (axisalignedbb1 != null && axisalignedbb1.intersects(boundingBox)) {
-                collidingBoundingBoxes.add(axisalignedbb1);
+            AABB aabb = entity.getBb();
+            if (aabb != null && aabb.intersects(boundingBox)) {
+                collidingBoundingBoxes.add(aabb);
             }
         }
 		
@@ -2043,19 +2039,19 @@ public class World implements WorldSource {
 		return false;
 	}
 
-    public boolean isBoundingBoxBurning(AABB axisalignedbb)
+    public boolean isBoundingBoxBurning(AABB aabb)
     {
-        return isMaterialInBB(axisalignedbb, Material.fire, Material.lava);
+        return isMaterialInBB(aabb, Material.fire, Material.lava);
     }
 
-    public boolean handleMaterialAcceleration(AABB axisalignedbb, Material material, Entity entity, boolean addVelocity)
+    public boolean handleMaterialAcceleration(AABB aabb, Material material, Entity entity, boolean addVelocity)
     {
-        int i = MathHelper.floor(axisalignedbb.minX);
-        int j = MathHelper.floor(axisalignedbb.maxX + 1.0D);
-        int k = MathHelper.floor(axisalignedbb.minY);
-        int l = MathHelper.floor(axisalignedbb.maxY + 1.0D);
-        int i1 = MathHelper.floor(axisalignedbb.minZ);
-        int j1 = MathHelper.floor(axisalignedbb.maxZ + 1.0D);
+        int i = MathHelper.floor(aabb.minX);
+        int j = MathHelper.floor(aabb.maxX + 1.0D);
+        int k = MathHelper.floor(aabb.minY);
+        int l = MathHelper.floor(aabb.maxY + 1.0D);
+        int i1 = MathHelper.floor(aabb.minZ);
+        int j1 = MathHelper.floor(aabb.maxZ + 1.0D);
         if(!areBlocksLoaded(i, k, i1, j, l, j1))
         {
             return false;
@@ -2069,7 +2065,7 @@ public class World implements WorldSource {
                 for(int i2 = i1; i2 < j1; i2++)
                 {
                     Block block = Block.blocksList[getBlockId(k1, l1, i2)];
-                    if(block == null || !isMaterialInBB(axisalignedbb, material))
+                    if(block == null || !isMaterialInBB(aabb, material))
                     {
                         continue;
                     }
@@ -2170,8 +2166,7 @@ public class World implements WorldSource {
         return false;
     }
 
-    public Explosion createExplosion(Entity entity, double x, double y, double z,
-                                     float explosionSize)
+    public Explosion createExplosion(Entity entity, double x, double y, double z, float explosionSize)
     {
         return newExplosion(entity, x, y, z, explosionSize, false, false);
     }
@@ -2226,7 +2221,7 @@ public class World implements WorldSource {
         z += side.getOffsetZ();
         if(getBlockId(x, y, z) == Blocks.FIRE.id)
         {
-            playBlockEvent(entityplayer, 1004, x, y, z, 0);
+            playBlockEvent(entityplayer, LevelListener.EVENT_FIRE_EXTINGUISH, x, y, z, 0);
             setBlockWithNotify(x, y, z, 0);
         }
     }
@@ -2366,7 +2361,7 @@ public class World implements WorldSource {
         lightingUpdatesCounter++;
         try
         {
-            for (int i = 499; lightingToUpdate.size() > 0 && i >= 0; i--)
+            for (int i = 499; !lightingToUpdate.isEmpty() && i >= 0; i--)
             {
                 lightingToUpdate.remove(lightingToUpdate.size() - 1).performLightUpdate(this);
                 if (i == 0)
@@ -2456,7 +2451,7 @@ public class World implements WorldSource {
         if(areEnoughPlayersFullyAsleep())
         {
             boolean wasInterrupted = false;
-            if(spawningConfig.canHostileSpawn(this) && getPlayersRequiredToSkipNight() <= 1)
+            if(getSpawnerConfig().canHostileSpawn(this) && getPlayersRequiredToSkipNight() <= 1)
             {
                 wasInterrupted = SpawnerMobs.performSleepSpawning(this, players);
             }
@@ -2479,7 +2474,7 @@ public class World implements WorldSource {
 		updateSleepingPlayers();
         Debug.change("spawning");
         // TODO mob spawning seems to be the cause of many lag spikes, specifically the checks for is a mob is allowed to spawn at a certain xyz position seem to be the worst offenders
-		SpawnerMobs.performSpawning(this, spawningConfig);
+		SpawnerMobs.performSpawning(this, getSpawnerConfig());
         Debug.change("chunk");
 		chunkProvider.tick();
 
@@ -2577,8 +2572,8 @@ public class World implements WorldSource {
                 blockX += chunkBlockX;
                 blockZ += chunkBlockZ;
                 if (id == 0 && getFullBlockLightValue(blockX, blockY, blockZ) <= rand.nextInt(8) && getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ) <= 0) {
-                    Player entityplayer1 = getClosestPlayer((double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, 8D);
-                    if (entityplayer1 != null && entityplayer1.distanceToSqr((double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D) > 4D) {
+                    Player closestPlayer = getClosestPlayer((double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, 8D);
+                    if (closestPlayer != null && closestPlayer.distanceToSqr((double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D) > 4D) {
                         playSoundEffect(null, SoundCategory.CAVE_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "ambient.cave.cave", 0.7F, 0.8F + rand.nextFloat() * 0.2F);
                         caveSoundCounter = rand.nextInt(12000) + 6000;
                     }
@@ -2616,9 +2611,9 @@ public class World implements WorldSource {
         {
             throw new IllegalStateException("TickNextTick list out of sync");
         }
-        if(count > 1000)
+        if(count > MAX_SCHEDULED_TICKS_IN_TICK)
         {
-            count = 1000;
+            count = MAX_SCHEDULED_TICKS_IN_TICK;
         }
         for(int j = 0; j < count; j++)
         {
@@ -2629,34 +2624,33 @@ public class World implements WorldSource {
             }
             scheduledTickTreeSet.remove(entry);
             scheduledTickSet.remove(entry);
-            byte byte0 = 8;
-            if(!areBlocksLoaded(entry.x - byte0, entry.y - byte0, entry.z - byte0, entry.x + byte0, entry.y + byte0, entry.z + byte0))
+            final byte radius = 8;
+            if(!areBlocksLoaded(entry.x - radius, entry.y - radius, entry.z - radius, entry.x + radius, entry.y + radius, entry.z + radius))
             {
                 continue;
             }
-            int k = getBlockId(entry.x, entry.y, entry.z);
-            if(k == entry.blockId && k > 0)
+            int blockId = getBlockId(entry.x, entry.y, entry.z);
+            if(blockId == entry.blockId && blockId > 0)
             {
-                Block.blocksList[k].updateTick(this, entry.x, entry.y, entry.z, rand);
+                Block.blocksList[blockId].updateTick(this, entry.x, entry.y, entry.z, rand);
             }
         }
 
-        return scheduledTickTreeSet.size() != 0;
+        return !scheduledTickTreeSet.isEmpty();
     }
 
     public void randomDisplayUpdates(int x, int y, int z)
     {
-        byte radius = 16;
+        final byte radius = 16;
         Random random = new Random();
-        for(int i = 0; i < 1000; i++)
+        for(int i = 0; i < ANIMATION_TICKS_PER_TICK; i++)
         {
             int rx = (x + rand.nextInt(radius)) - rand.nextInt(radius);
             int ry = (y + rand.nextInt(radius)) - rand.nextInt(radius);
             int rz = (z + rand.nextInt(radius)) - rand.nextInt(radius);
-            int id = getBlockId(rx, ry, rz);
-            if(id > 0)
-            {
-                Block.blocksList[id].animationTick(this, rx, ry, rz, random);
+            Block block = getBlock(rx, ry, rz);
+            if (block != null) {
+                block.animationTick(this, rx, ry, rz, random);
             }
         }
 
@@ -2756,7 +2750,8 @@ public class World implements WorldSource {
 
     public void dropOldChunks()
     {
-        while(chunkProvider.tick()) ;
+        // TODO chunkProvider#tick should be renamed, current name is extremely misleading as its called "tick" whilst not even being remotely connected to the actual tick system
+        while(chunkProvider.tick());
     }
 
     public boolean canBlockBePlacedAt(int blockId, int x, int y, int z, boolean flag, Side side)
@@ -2799,20 +2794,20 @@ public class World implements WorldSource {
         return (new PathFinder(chunkcache)).findPath(entity, entityToTravelTo, distance);
     }
 
-    public Path getEntityPathToXYZ(Entity entity, int i, int j, int k, float f)
+    public Path getEntityPathToXYZ(Entity entity, int x, int y, int z, float distance)
     {
-        int l = MathHelper.floor(entity.x);
-        int i1 = MathHelper.floor(entity.y);
-        int j1 = MathHelper.floor(entity.z);
-        int k1 = (int)(f + 8F);
-        int l1 = l - k1;
-        int i2 = i1 - k1;
-        int j2 = j1 - k1;
-        int k2 = l + k1;
-        int l2 = i1 + k1;
-        int i3 = j1 + k1;
-        ChunkCache chunkcache = new ChunkCache(this, l1, i2, j2, k2, l2, i3);
-        return (new PathFinder(chunkcache)).findPath(entity, i, j, k, f);
+        int eBlockX = MathHelper.floor(entity.x);
+        int eBlockY = MathHelper.floor(entity.y);
+        int eBlockZ = MathHelper.floor(entity.z);
+        int cacheRadius = (int)(distance + 8F);
+        int cacheMinX = eBlockX - cacheRadius;
+        int cacheMinY = eBlockY - cacheRadius;
+        int cacheMinZ = eBlockZ - cacheRadius;
+        int cacheMaxX = eBlockX + cacheRadius;
+        int cacheMaxY = eBlockY + cacheRadius;
+        int cacheMaxZ = eBlockZ + cacheRadius;
+        ChunkCache chunkcache = new ChunkCache(this, cacheMinX, cacheMinY, cacheMinZ, cacheMaxX, cacheMaxY, cacheMaxZ);
+        return (new PathFinder(chunkcache)).findPath(entity, x, y, z, distance);
     }
 
     public boolean getDirectSignal(int x, int y, int z, Side side) {
@@ -3035,9 +3030,7 @@ public class World implements WorldSource {
     public void setWorldTimeUpdateTicks(long l)
     {
         long l1 = l - levelData.getWorldTime();
-        for(Iterator iterator = scheduledTickSet.iterator(); iterator.hasNext();)
-        {
-            NextTickListEntry nextticklistentry = (NextTickListEntry)iterator.next();
+        for (NextTickListEntry nextticklistentry : scheduledTickSet) {
             nextticklistentry.delay += l1;
         }
 
